Index: LMDZ5/branches/testing/libf/phylmd/calltherm.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/calltherm.F90	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/calltherm.F90	(revision 1669)
@@ -8,5 +8,14 @@
      &      ,fm_therm,entr_therm,detr_therm,zqasc,clwcon0,lmax,ratqscth,  &
      &       ratqsdiff,zqsatth,Ale_bl,Alp_bl,lalim_conv,wght_th, &
-     &       zmax0,f0,zw2,fraca,ztv,zpspsk,ztla,zthl)
+     &       zmax0,f0,zw2,fraca,ztv,zpspsk,ztla,zthl &
+!!! nrlmd le 10/04/2012
+     &      ,pbl_tke,pctsrf,omega,airephy &
+     &      ,zlcl_th,fraca0,w0,w_conv,therm_tke_max0,env_tke_max0 &
+     &      ,n2,s2,ale_bl_stat &
+     &      ,therm_tke_max,env_tke_max &
+     &      ,alp_bl_det,alp_bl_fluct_m,alp_bl_fluct_tke &
+     &      ,alp_bl_conv,alp_bl_stat &
+!!! fin nrlmd le 10/04/2012
+     &                    )
 
       USE dimphy
@@ -16,4 +25,8 @@
 #include "thermcell.h"
 #include "iniprint.h"
+
+!!! nrlmd le 10/04/2012
+#include "indicesol.h"
+!!! fin nrlmd le 10/04/2012
 
 !IM 140508
@@ -75,4 +88,18 @@
       !on garde le zmax du pas de temps precedent
       real zmax0(klon), f0(klon)
+
+!!! nrlmd le 10/04/2012
+      real pbl_tke(klon,klev+1,nbsrf)
+      real pctsrf(klon,nbsrf)
+      real omega(klon,klev)
+      real airephy(klon)
+      real zlcl_th(klon),fraca0(klon),w0(klon),w_conv(klon)
+      real therm_tke_max0(klon),env_tke_max0(klon)
+      real n2(klon),s2(klon)
+      real ale_bl_stat(klon)
+      real therm_tke_max(klon,klev),env_tke_max(klon,klev)
+      real alp_bl_det(klon),alp_bl_fluct_m(klon),alp_bl_fluct_tke(klon),alp_bl_conv(klon),alp_bl_stat(klon)
+!!! fin nrlmd le 10/04/2012
+
 !********************************************************
 
@@ -220,5 +247,14 @@
      &      ,Ale,Alp,lalim_conv,wght_th &
      &      ,zmax0,f0,zw2,fraca,ztv,zpspsk &
-     &      ,ztla,zthl)
+     &      ,ztla,zthl &
+!!! nrlmd le 10/04/2012
+     &      ,pbl_tke,pctsrf,omega,airephy &
+     &      ,zlcl_th,fraca0,w0,w_conv,therm_tke_max0,env_tke_max0 &
+     &      ,n2,s2,ale_bl_stat &
+     &      ,therm_tke_max,env_tke_max &
+     &      ,alp_bl_det,alp_bl_fluct_m,alp_bl_fluct_tke &
+     &      ,alp_bl_conv,alp_bl_stat &
+!!! fin nrlmd le 10/04/2012
+     &                         )
            if (prt_level.gt.10) write(lunout,*)'Apres thermcell_main OK'
          else
@@ -227,5 +263,20 @@
          endif
 
-       flag_bidouille_stratocu=iflag_thermals.eq.14.or.iflag_thermals.eq.16
+! Attention : les noms sont contre intuitif.
+! flag_bidouille_stratocu est .true. si on ne fait pas de bidouille.
+! Il aurait mieux valu avoir un nobidouille_stratocu
+! Et pour simplifier :
+! nobidouille_stratocu=.not.(iflag_thermals==13.or.iflag_thermals=15)
+! Ce serait bien de changer, mai en prenant le temps de vérifier que ca
+! fait bien ce qu'on croit.
+
+       flag_bidouille_stratocu=iflag_thermals<=12.or.iflag_thermals==14.or.iflag_thermals==16
+
+      if (iflag_thermals<=12) then
+         lmax=1
+         do k=1,klev-1
+            zdetr_therm(:,k)=zentr_therm(:,k)+zfm_therm(:,k)-zfm_therm(:,k+1)
+         enddo
+      endif
 
       fact(:)=0.
@@ -267,5 +318,4 @@
 
        DO i=1,klon
-        if(prt_level.GE.10) print*,'calltherm i Alp_bl Alp Ale_bl Ale',i,Alp_bl(i),Alp(i),Ale_bl(i),Ale(i)
             fm_therm(i,klev+1)=0.
             Ale_bl(i)=Ale_bl(i)+Ale(i)/REAL(nsplit_thermals)
@@ -273,4 +323,5 @@
             Alp_bl(i)=Alp_bl(i)+Alp(i)/REAL(nsplit_thermals)
 !            write(23,*)'ALP CALLTHERM',Alp_bl(i),Alp(i)
+        if(prt_level.GE.10) print*,'calltherm i Alp_bl Alp Ale_bl Ale',i,Alp_bl(i),Alp(i),Ale_bl(i),Ale(i)
        ENDDO
 
Index: LMDZ5/branches/testing/libf/phylmd/concvl.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/concvl.F	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/concvl.F	(revision 1669)
@@ -248,5 +248,5 @@
          DO i = 1, klon
           cbmf(i) = 0.
-!          plcl(i) = 0.
+          plcl(i) = 0.
           sigd(i) = 0.
          ENDDO
@@ -256,5 +256,4 @@
       plfc(:)  = 0.
       wbeff(:) = 100.
-      plcl(:) = 0.
 
       DO k = 1, klev+1
@@ -369,5 +368,8 @@
      $              cape,cin,tvp,
      $              dd_t,dd_q,Plim1,Plim2,asupmax,supmax0,
-     $              asupmaxmin,lalim_conv)
+     $              asupmaxmin,lalim_conv,
+!AC!
+     $              da,phi)
+!AC!
       endif  
 C------------------------------------------------------------------
@@ -399,4 +401,16 @@
        ENDDO 
        endif
+
+c!AC!
+       if (iflag_con.eq.3) then
+       DO itra = 1,ntra
+        DO k = 1, klev
+         DO i = 1, klon
+            d_tra(i,k,itra) =dtime*d_tra(i,k,itra) 
+         ENDDO
+        ENDDO
+       ENDDO 
+       endif
+c!AC!
 
       DO k = 1, klev
Index: LMDZ5/branches/testing/libf/phylmd/conf_phys.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/conf_phys.F90	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/conf_phys.F90	(revision 1669)
@@ -110,4 +110,9 @@
   integer,SAVE :: iflag_thermals_omp,nsplit_thermals_omp
   real,save :: tau_thermals_omp,alp_bl_k_omp
+!!! nrlmd le 10/04/2012
+  integer,SAVE :: iflag_trig_bl_omp,iflag_clos_bl_omp
+  integer,SAVE :: tau_trig_shallow_omp,tau_trig_deep_omp
+  real,SAVE    :: s_trig_omp
+!!! fin nrlmd le 10/04/2012
   real :: alp_offset
   REAL, SAVE :: alp_offset_omp
@@ -282,4 +287,5 @@
 !Config Help = Used in physiq.F
 !
+! - flag_aerosol=0 => no aerosol
 ! - flag_aerosol=1 => so4 only (defaut) 
 ! - flag_aerosol=2 => bc  only 
@@ -289,5 +295,5 @@
 ! - flag_aerosol=6 => all aerosol
 
-  flag_aerosol_omp = 1
+  flag_aerosol_omp = 0
   CALL getin('flag_aerosol',flag_aerosol_omp)
 
@@ -1083,4 +1089,48 @@
   alp_bl_k_omp = 1.
   call getin('alp_bl_k',alp_bl_k_omp)
+
+!!! nrlmd le 10/04/2012
+
+!Config Key  = iflag_trig_bl
+!Config Desc =  
+!Config Def  = 0
+!Config Help = 
+!
+  iflag_trig_bl_omp = 0
+  call getin('iflag_trig_bl',iflag_trig_bl_omp)
+
+!Config Key  = s_trig_bl
+!Config Desc =  
+!Config Def  = 0
+!Config Help = 
+!
+  s_trig_omp = 2e7
+  call getin('s_trig',s_trig_omp)
+
+!Config Key  = tau_trig_shallow
+!Config Desc =  
+!Config Def  = 0
+!Config Help = 
+!
+  tau_trig_shallow_omp = 600
+  call getin('tau_trig_shallow',tau_trig_shallow_omp)
+
+!Config Key  = tau_trig_deep
+!Config Desc =  
+!Config Def  = 0
+!Config Help = 
+!
+  tau_trig_deep_omp = 1800
+  call getin('tau_trig_deep',tau_trig_deep_omp)
+
+!Config Key  = iflag_clos_bl
+!Config Desc =  
+!Config Def  = 0
+!Config Help = 
+!
+  iflag_clos_bl_omp = 0
+  call getin('iflag_clos_bl',iflag_clos_bl_omp)
+
+!!! fin nrlmd le 10/04/2012
 
 !
@@ -1650,4 +1700,11 @@
     tau_thermals = tau_thermals_omp
     alp_bl_k = alp_bl_k_omp
+!!! nrlmd le 10/04/2012
+    iflag_trig_bl = iflag_trig_bl_omp
+    s_trig = s_trig_omp
+    tau_trig_shallow = tau_trig_shallow_omp
+    tau_trig_deep = tau_trig_deep_omp
+    iflag_clos_bl = iflag_clos_bl_omp
+!!! fin nrlmd le 10/04/2012
     iflag_coupl = iflag_coupl_omp
     iflag_clos = iflag_clos_omp
@@ -1710,4 +1767,7 @@
 ! il n'est utilisable que lors du couplage avec le SO4 seul 
     IF (ok_ade .OR. ok_aie) THEN 
+       IF ( flag_aerosol .EQ. 0 ) THEN
+          CALL abort_gcm('conf_phys','flag_aerosol=0 not compatible avec ok_ade ou ok_aie=.TRUE.',1)
+       END IF
        IF ( .NOT. new_aod .AND.  flag_aerosol .NE. 1) THEN
           CALL abort_gcm('conf_phys','new_aod=.FALSE. not compatible avec flag_aerosol=1',1)
@@ -1839,4 +1899,11 @@
   write(lunout,*)' iflag_wake = ', iflag_wake
   write(lunout,*)' alp_offset = ', alp_offset
+!!! nrlmd le 10/04/2012
+  write(lunout,*)' iflag_trig_bl = ', iflag_trig_bl
+  write(lunout,*)' s_trig = ', s_trig
+  write(lunout,*)' tau_trig_shallow = ', tau_trig_shallow
+  write(lunout,*)' tau_trig_deep = ', tau_trig_deep
+  write(lunout,*)' iflag_clos_bl = ', iflag_clos_bl
+!!! fin nrlmd le 10/04/2012
 
   write(lunout,*)' lonmin lonmax latmin latmax bilKP_ins =',&
Index: LMDZ5/branches/testing/libf/phylmd/cv3_routines.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3_routines.F	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/cv3_routines.F	(revision 1669)
@@ -879,16 +879,16 @@
  110  continue
 
-      do 121 j=1,ntra
-ccccc      do 111 k=1,nl+1
-      do 111 k=1,nd
-       nn=0
-      do 101 i=1,len
-      if(iflag1(i).eq.0)then
-       nn=nn+1
-       tra(nn,k,j)=tra1(i,k,j)
-      endif
- 101  continue
- 111  continue
- 121  continue
+!AC!      do 121 j=1,ntra
+!AC!ccccc      do 111 k=1,nl+1
+!AC!      do 111 k=1,nd
+!AC!       nn=0
+!AC!      do 101 i=1,len
+!AC!      if(iflag1(i).eq.0)then
+!AC!       nn=nn+1
+!AC!       tra(nn,k,j)=tra1(i,k,j)
+!AC!      endif
+!AC! 101  continue
+!AC! 111  continue
+!AC! 121  continue
 
       if (nn.ne.ncum) then
@@ -1633,13 +1633,13 @@
       sij(1:ncum,1:nd,1:nd)=0.0
       
-      do k=1,ntra
-       do j=1,nd  ! instead nlp
-        do i=1,nd ! instead nlp
-         do il=1,ncum
-            traent(il,i,j,k)=tra(il,j,k)
-         enddo
-        enddo
-       enddo
-      enddo
+!AC!      do k=1,ntra
+!AC!       do j=1,nd  ! instead nlp
+!AC!        do i=1,nd ! instead nlp
+!AC!         do il=1,ncum
+!AC!            traent(il,i,j,k)=tra(il,j,k)
+!AC!         enddo
+!AC!        enddo
+!AC!       enddo
+!AC!      enddo
       zm(:,:)=0.
 
@@ -1697,15 +1697,15 @@
  710  continue
 
-       do k=1,ntra
-        do j=minorig,nl
-         do il=1,ncum
-          if( (i.ge.icb(il)).and.(i.le.inb(il)).and.
-     :       (j.ge.(icb(il)-1)).and.(j.le.inb(il)))then
-            traent(il,i,j,k)=sij(il,i,j)*tra(il,i,k)
-     :            +(1.-sij(il,i,j))*tra(il,nk(il),k)
-          endif
-         enddo
-        enddo
-       enddo
+!AC!       do k=1,ntra
+!AC!        do j=minorig,nl
+!AC!         do il=1,ncum
+!AC!          if( (i.ge.icb(il)).and.(i.le.inb(il)).and.
+!AC!     :       (j.ge.(icb(il)-1)).and.(j.le.inb(il)))then
+!AC!            traent(il,i,j,k)=sij(il,i,j)*tra(il,i,k)
+!AC!     :            +(1.-sij(il,i,j))*tra(il,nk(il),k)
+!AC!          endif
+!AC!         enddo
+!AC!        enddo
+!AC!       enddo
 
 c
@@ -1730,13 +1730,13 @@
  750  continue
 
-      do j=1,ntra
-       do i=minorig+1,nl
-        do il=1,ncum
-         if (i.ge.icb(il) .and. i.le.inb(il) .and. nent(il,i).eq.0) then
-          traent(il,i,i,j)=tra(il,nk(il),j)
-         endif
-        enddo
-       enddo
-      enddo
+!AC!      do j=1,ntra
+!AC!       do i=minorig+1,nl
+!AC!        do il=1,ncum
+!AC!         if (i.ge.icb(il) .and. i.le.inb(il) .and. nent(il,i).eq.0) then
+!AC!          traent(il,i,i,j)=tra(il,nk(il),j)
+!AC!         endif
+!AC!        enddo
+!AC!       enddo
+!AC!      enddo
 
       do 100 j=minorig,nl
@@ -1904,12 +1904,12 @@
       enddo ! il
 
-      do j=1,ntra
-       do il=1,ncum
-        if ( i.ge.icb(il) .and. i.le.inb(il) .and. lwork(il)
-     :     .and. csum(il,i).lt.m(il,i) ) then
-         traent(il,i,i,j)=tra(il,nk(il),j)
-        endif
-       enddo
-      enddo
+!AC!      do j=1,ntra
+!AC!       do il=1,ncum
+!AC!        if ( i.ge.icb(il) .and. i.le.inb(il) .and. lwork(il)
+!AC!     :     .and. csum(il,i).lt.m(il,i) ) then
+!AC!         traent(il,i,i,j)=tra(il,nk(il),j)
+!AC!        endif
+!AC!       enddo
+!AC!      enddo
 789   continue
 c      
@@ -2014,11 +2014,11 @@
          enddo
         enddo
-        do k=1,ntra
-         do i=1,nd
-          do il=1,ncum
-           trap(il,i,k)=tra(il,i,k)
-          enddo
-         enddo
-        enddo
+!AC!        do k=1,ntra
+!AC!         do i=1,nd
+!AC!          do il=1,ncum
+!AC!           trap(il,i,k)=tra(il,i,k)
+!AC!          enddo
+!AC!         enddo
+!AC!        enddo
 c
 c   ***  check whether ep(inb)=0, if so, skip precipitating    ***
@@ -2341,21 +2341,21 @@
 c    ***       find tracer concentrations in precipitating downdraft     ***
 c
-      do j=1,ntra
-       do il = 1,ncum
-       if (i.lt.inb(il) .and. lwork(il)) then
-c
-         if(mplus(il))then
-          trap(il,i,j)=trap(il,i+1,j)*mp(il,i+1)
-     :              +trap(il,i,j)*(mp(il,i)-mp(il,i+1))
-          trap(il,i,j)=trap(il,i,j)/mp(il,i)
-         else ! if (mplus(il))
-          if(mp(il,i+1).gt.1.0e-16)then
-           trap(il,i,j)=trap(il,i+1,j)
-          endif
-         endif ! (mplus(il)) else if (.not.mplus(il))
-c
-        endif ! (i.lt.inb(il) .and. lwork(il))
-       enddo
-      end do
+!AC!      do j=1,ntra
+!AC!       do il = 1,ncum
+!AC!       if (i.lt.inb(il) .and. lwork(il)) then
+!AC!c
+!AC!         if(mplus(il))then
+!AC!          trap(il,i,j)=trap(il,i+1,j)*mp(il,i+1)
+!AC!     :              +trap(il,i,j)*(mp(il,i)-mp(il,i+1))
+!AC!          trap(il,i,j)=trap(il,i,j)/mp(il,i)
+!AC!         else ! if (mplus(il))
+!AC!          if(mp(il,i+1).gt.1.0e-16)then
+!AC!           trap(il,i,j)=trap(il,i+1,j)
+!AC!          endif
+!AC!         endif ! (mplus(il)) else if (.not.mplus(il))
+!AC!c
+!AC!        endif ! (i.lt.inb(il) .and. lwork(il))
+!AC!       enddo
+!AC!      end do
 
 400   continue
@@ -2484,11 +2484,11 @@
       enddo
 c       print*,'cv3_yield initialisation 2'
-      do j=1,ntra
-       do i=1,nd
-        do il=1,ncum
-          ftra(il,i,j)=0.0
-        enddo
-       enddo
-      enddo
+!AC!      do j=1,ntra
+!AC!       do i=1,nd
+!AC!        do il=1,ncum
+!AC!          ftra(il,i,j)=0.0
+!AC!        enddo
+!AC!       enddo
+!AC!      enddo
 c       print*,'cv3_yield initialisation 3'
       do i=1,nl
@@ -2649,19 +2649,19 @@
 
 
-      do j=1,ntra
-       do il=1,ncum
-        if (iflag(il) .le. 1) then
-        if (cvflag_grav) then
-         ftra(il,1,j)=ftra(il,1,j)+0.01*grav*work(il)
-     :                     *(mp(il,2)*(trap(il,2,j)-tra(il,1,j))
-     :             +am(il)*(tra(il,2,j)-tra(il,1,j)))
-        else
-         ftra(il,1,j)=ftra(il,1,j)+0.1*work(il)
-     :                     *(mp(il,2)*(trap(il,2,j)-tra(il,1,j))
-     :             +am(il)*(tra(il,2,j)-tra(il,1,j)))
-        endif
-        endif  ! iflag
-       enddo
-      enddo
+!AC!     do j=1,ntra
+!AC!      do il=1,ncum
+!AC!       if (iflag(il) .le. 1) then
+!AC!       if (cvflag_grav) then
+!AC!        ftra(il,1,j)=ftra(il,1,j)+0.01*grav*work(il)
+!AC!    :                     *(mp(il,2)*(trap(il,2,j)-tra(il,1,j))
+!AC!    :             +am(il)*(tra(il,2,j)-tra(il,1,j)))
+!AC!       else
+!AC!        ftra(il,1,j)=ftra(il,1,j)+0.1*work(il)
+!AC!    :                     *(mp(il,2)*(trap(il,2,j)-tra(il,1,j))
+!AC!    :             +am(il)*(tra(il,2,j)-tra(il,1,j)))
+!AC!       endif
+!AC!       endif  ! iflag
+!AC!      enddo
+!AC!     enddo
 
        do j=2,nl
@@ -2687,21 +2687,21 @@
       enddo
 
-      do k=1,ntra
-       do j=2,nl
-        do il=1,ncum
-         if (j.le.inb(il) .and. iflag(il) .le. 1) then
-
-          if (cvflag_grav) then
-           ftra(il,1,k)=ftra(il,1,k)+0.01*grav*work(il)*ment(il,j,1)
-     :                *(traent(il,j,1,k)-tra(il,1,k))
-          else
-           ftra(il,1,k)=ftra(il,1,k)+0.1*work(il)*ment(il,j,1)
-     :                *(traent(il,j,1,k)-tra(il,1,k))
-          endif
-
-         endif
-        enddo
-       enddo
-      enddo
+!AC!      do k=1,ntra
+!AC!       do j=2,nl
+!AC!        do il=1,ncum
+!AC!         if (j.le.inb(il) .and. iflag(il) .le. 1) then
+!AC!
+!AC!          if (cvflag_grav) then
+!AC!           ftra(il,1,k)=ftra(il,1,k)+0.01*grav*work(il)*ment(il,j,1)
+!AC!     :                *(traent(il,j,1,k)-tra(il,1,k))
+!AC!          else
+!AC!           ftra(il,1,k)=ftra(il,1,k)+0.1*work(il)*ment(il,j,1)
+!AC!     :                *(traent(il,j,1,k)-tra(il,1,k))
+!AC!          endif
+!AC!
+!AC!         endif
+!AC!        enddo
+!AC!       enddo
+!AC!      enddo
 c      print*,'cv3_yield apres ft'
 c
@@ -2865,21 +2865,21 @@
 1350  continue
 
-      do k=1,ntra
-       do il=1,ncum
-        if (i.le.inb(il) .and. iflag(il) .le. 1) then
-         dpinv=1.0/(ph(il,i)-ph(il,i+1))
-         cpinv=1.0/cpn(il,i)
-         if (cvflag_grav) then
-           ftra(il,i,k)=ftra(il,i,k)+0.01*grav*dpinv
-     :         *(amp1(il)*(tra(il,i+1,k)-tra(il,i,k))
-     :           -ad(il)*(tra(il,i,k)-tra(il,i-1,k)))
-         else
-           ftra(il,i,k)=ftra(il,i,k)+0.1*dpinv
-     :         *(amp1(il)*(tra(il,i+1,k)-tra(il,i,k))
-     :           -ad(il)*(tra(il,i,k)-tra(il,i-1,k)))
-         endif
-        endif
-       enddo
-      enddo
+!AC!      do k=1,ntra
+!AC!       do il=1,ncum
+!AC!        if (i.le.inb(il) .and. iflag(il) .le. 1) then
+!AC!         dpinv=1.0/(ph(il,i)-ph(il,i+1))
+!AC!         cpinv=1.0/cpn(il,i)
+!AC!         if (cvflag_grav) then
+!AC!           ftra(il,i,k)=ftra(il,i,k)+0.01*grav*dpinv
+!AC!     :         *(amp1(il)*(tra(il,i+1,k)-tra(il,i,k))
+!AC!     :           -ad(il)*(tra(il,i,k)-tra(il,i-1,k)))
+!AC!         else
+!AC!           ftra(il,i,k)=ftra(il,i,k)+0.1*dpinv
+!AC!     :         *(amp1(il)*(tra(il,i+1,k)-tra(il,i,k))
+!AC!     :           -ad(il)*(tra(il,i,k)-tra(il,i-1,k)))
+!AC!         endif
+!AC!        endif
+!AC!       enddo
+!AC!      enddo
 
       do 480 k=1,i-1
@@ -2938,21 +2938,21 @@
 480   continue
 
-      do j=1,ntra
-       do k=1,i-1
-        do il=1,ncum
-         if (i.le.inb(il) .and. iflag(il) .le. 1) then
-          dpinv=1.0/(ph(il,i)-ph(il,i+1))
-          cpinv=1.0/cpn(il,i)
-          if (cvflag_grav) then
-           ftra(il,i,j)=ftra(il,i,j)+0.01*grav*dpinv*ment(il,k,i)
-     :        *(traent(il,k,i,j)-tra(il,i,j))
-          else
-           ftra(il,i,j)=ftra(il,i,j)+0.1*dpinv*ment(il,k,i)
-     :        *(traent(il,k,i,j)-tra(il,i,j))
-          endif
-         endif
-        enddo
-       enddo
-      enddo
+!AC!      do j=1,ntra
+!AC!       do k=1,i-1
+!AC!        do il=1,ncum
+!AC!         if (i.le.inb(il) .and. iflag(il) .le. 1) then
+!AC!          dpinv=1.0/(ph(il,i)-ph(il,i+1))
+!AC!          cpinv=1.0/cpn(il,i)
+!AC!          if (cvflag_grav) then
+!AC!           ftra(il,i,j)=ftra(il,i,j)+0.01*grav*dpinv*ment(il,k,i)
+!AC!     :        *(traent(il,k,i,j)-tra(il,i,j))
+!AC!          else
+!AC!           ftra(il,i,j)=ftra(il,i,j)+0.1*dpinv*ment(il,k,i)
+!AC!     :        *(traent(il,k,i,j)-tra(il,i,j))
+!AC!          endif
+!AC!         endif
+!AC!        enddo
+!AC!       enddo
+!AC!      enddo
 
       do 490 k=i,nl+1
@@ -3004,22 +3004,22 @@
 490   continue
 
-      do j=1,ntra
-       do k=i,nl+1
-        do il=1,ncum
-         if (i.le.inb(il) .and. k.le.inb(il)
-     $                .and. iflag(il) .le. 1) then
-          dpinv=1.0/(ph(il,i)-ph(il,i+1))
-          cpinv=1.0/cpn(il,i)
-          if (cvflag_grav) then
-           ftra(il,i,j)=ftra(il,i,j)+0.01*grav*dpinv*ment(il,k,i)
-     :         *(traent(il,k,i,j)-tra(il,i,j))
-          else
-           ftra(il,i,j)=ftra(il,i,j)+0.1*dpinv*ment(il,k,i)
-     :             *(traent(il,k,i,j)-tra(il,i,j))
-          endif
-         endif ! i and k
-        enddo
-       enddo
-      enddo
+!AC!      do j=1,ntra
+!AC!       do k=i,nl+1
+!AC!        do il=1,ncum
+!AC!         if (i.le.inb(il) .and. k.le.inb(il)
+!AC!     $                .and. iflag(il) .le. 1) then
+!AC!          dpinv=1.0/(ph(il,i)-ph(il,i+1))
+!AC!          cpinv=1.0/cpn(il,i)
+!AC!          if (cvflag_grav) then
+!AC!           ftra(il,i,j)=ftra(il,i,j)+0.01*grav*dpinv*ment(il,k,i)
+!AC!     :         *(traent(il,k,i,j)-tra(il,i,j))
+!AC!          else
+!AC!           ftra(il,i,j)=ftra(il,i,j)+0.1*dpinv*ment(il,k,i)
+!AC!     :             *(traent(il,k,i,j)-tra(il,i,j))
+!AC!          endif
+!AC!         endif ! i and k
+!AC!        enddo
+!AC!       enddo
+!AC!      enddo
 
 c sb: interface with the cloud parameterization:          ! cld
@@ -3052,22 +3052,22 @@
       enddo
 
-      do j=1,ntra
-       do il=1,ncum
-        if (i.le.inb(il) .and. iflag(il) .le. 1) then
-         dpinv=1.0/(ph(il,i)-ph(il,i+1))
-         cpinv=1.0/cpn(il,i)
-
-         if (cvflag_grav) then
-          ftra(il,i,j)=ftra(il,i,j)+0.01*grav*dpinv
-     :     *(mp(il,i+1)*(trap(il,i+1,j)-tra(il,i,j))
-     :     -mp(il,i)*(trap(il,i,j)-trap(il,i-1,j)))
-         else
-          ftra(il,i,j)=ftra(il,i,j)+0.1*dpinv
-     :     *(mp(il,i+1)*(trap(il,i+1,j)-tra(il,i,j))
-     :     -mp(il,i)*(trap(il,i,j)-trap(il,i-1,j)))
-         endif
-        endif ! i
-       enddo
-      enddo
+!AC!      do j=1,ntra
+!AC!       do il=1,ncum
+!AC!        if (i.le.inb(il) .and. iflag(il) .le. 1) then
+!AC!         dpinv=1.0/(ph(il,i)-ph(il,i+1))
+!AC!         cpinv=1.0/cpn(il,i)
+!AC!
+!AC!         if (cvflag_grav) then
+!AC!          ftra(il,i,j)=ftra(il,i,j)+0.01*grav*dpinv
+!AC!     :     *(mp(il,i+1)*(trap(il,i+1,j)-tra(il,i,j))
+!AC!     :     -mp(il,i)*(trap(il,i,j)-trap(il,i-1,j)))
+!AC!         else
+!AC!          ftra(il,i,j)=ftra(il,i,j)+0.1*dpinv
+!AC!     :     *(mp(il,i+1)*(trap(il,i+1,j)-tra(il,i,j))
+!AC!     :     -mp(il,i)*(trap(il,i,j)-trap(il,i-1,j)))
+!AC!         endif
+!AC!        endif ! i
+!AC!       enddo
+!AC!      enddo
 
 
@@ -3146,27 +3146,27 @@
 503   continue
 
-      do j=1,ntra
-       do il=1,ncum
-        IF (iflag(il) .le. 1) THEN
-	IF (cvflag_grav) then
-        ex=0.01*grav*ment(il,inb(il),inb(il))
-     :      *(traent(il,inb(il),inb(il),j)-tra(il,inb(il),j))
-     :      /(ph(i l,inb(il))-ph(il,inb(il)+1))
-        ftra(il,inb(il),j)=ftra(il,inb(il),j)-ex
-        ftra(il,inb(il)-1,j)=ftra(il,inb(il)-1,j)
-     :       +ex*(ph(il,inb(il))-ph(il,inb(il)+1))
-     :          /(ph(il,inb(il)-1)-ph(il,inb(il)))
-	else
-        ex=0.1*ment(il,inb(il),inb(il))
-     :      *(traent(il,inb(il),inb(il),j)-tra(il,inb(il),j))
-     :      /(ph(i l,inb(il))-ph(il,inb(il)+1))
-        ftra(il,inb(il),j)=ftra(il,inb(il),j)-ex
-        ftra(il,inb(il)-1,j)=ftra(il,inb(il)-1,j)
-     :       +ex*(ph(il,inb(il))-ph(il,inb(il)+1))
-     :          /(ph(il,inb(il)-1)-ph(il,inb(il)))
-        ENDIF   !cvflag grav
-        ENDIF    !iflag
-       enddo
-      enddo
+!AC!      do j=1,ntra
+!AC!       do il=1,ncum
+!AC!        IF (iflag(il) .le. 1) THEN
+!AC!	IF (cvflag_grav) then
+!AC!        ex=0.01*grav*ment(il,inb(il),inb(il))
+!AC!     :      *(traent(il,inb(il),inb(il),j)-tra(il,inb(il),j))
+!AC!     :      /(ph(i l,inb(il))-ph(il,inb(il)+1))
+!AC!        ftra(il,inb(il),j)=ftra(il,inb(il),j)-ex
+!AC!        ftra(il,inb(il)-1,j)=ftra(il,inb(il)-1,j)
+!AC!     :       +ex*(ph(il,inb(il))-ph(il,inb(il)+1))
+!AC!     :          /(ph(il,inb(il)-1)-ph(il,inb(il)))
+!AC!	else
+!AC!        ex=0.1*ment(il,inb(il),inb(il))
+!AC!     :      *(traent(il,inb(il),inb(il),j)-tra(il,inb(il),j))
+!AC!     :      /(ph(i l,inb(il))-ph(il,inb(il)+1))
+!AC!        ftra(il,inb(il),j)=ftra(il,inb(il),j)-ex
+!AC!        ftra(il,inb(il)-1,j)=ftra(il,inb(il)-1,j)
+!AC!     :       +ex*(ph(il,inb(il))-ph(il,inb(il)+1))
+!AC!     :          /(ph(il,inb(il)-1)-ph(il,inb(il)))
+!AC!        ENDIF   !cvflag grav
+!AC!        ENDIF    !iflag
+!AC!       enddo
+!AC!      enddo
 
 c
@@ -3287,13 +3287,14 @@
       ENDDO
       ENDDO
-      DO j = 1,ntra
-      DO i = 1,nl
-       DO il = 1,ncum
-        IF (iflag(il) .le. 1) THEN
-         ftra(il,i,j) = ftra(il,i,j)/alpha_qpos(il)
-        ENDIF
-       ENDDO
-      ENDDO
-      ENDDO
+
+!AC!      DO j = 1,ntra
+!AC!      DO i = 1,nl
+!AC!       DO il = 1,ncum
+!AC!        IF (iflag(il) .le. 1) THEN
+!AC!         ftra(il,i,j) = ftra(il,i,j)/alpha_qpos(il)
+!AC!        ENDIF
+!AC!       ENDDO
+!AC!      ENDDO
+!AC!      ENDDO
 
 c
@@ -3539,4 +3540,29 @@
         end
 
+!AC!
+      SUBROUTINE cv3_tracer(nloc,len,ncum,nd,na,
+     &                        ment,sij,da,phi)
+        implicit none
+c inputs:
+        integer ncum, nd, na, nloc,len
+        real ment(nloc,na,na),sij(nloc,na,na)
+c ouputs:
+        real da(nloc,na),phi(nloc,na,na)
+c local variables:
+        integer i,j,k
+c        
+        da(:,:)=0.
+c
+        do j=1,na
+          do k=1,na
+            do i=1,ncum
+            da(i,j)=da(i,j)+(1.-sij(i,k,j))*ment(i,k,j)
+            phi(i,j,k)=sij(i,k,j)*ment(i,k,j)
+            end do 
+          end do 
+        end do 
+        return
+        end
+!AC!
 
       SUBROUTINE cv3_uncompress(nloc,len,ncum,nd,ntra,idcum
@@ -3609,12 +3635,12 @@
 
 
-        do 2100 j=1,ntra
-c oct3         do 2110 k=1,nl
-         do 2110 k=1,nd ! oct3
-          do 2120 i=1,ncum
-            ftra1(idcum(i),k,j)=ftra(i,k,j)
- 2120     continue
- 2110    continue
- 2100   continue
+!AC!        do 2100 j=1,ntra
+!AC!c oct3         do 2110 k=1,nl
+!AC!         do 2110 k=1,nd ! oct3
+!AC!          do 2120 i=1,ncum
+!AC!            ftra1(idcum(i),k,j)=ftra(i,k,j)
+!AC! 2120     continue
+!AC! 2110    continue
+!AC! 2100   continue
         return
         end
Index: LMDZ5/branches/testing/libf/phylmd/cv3a_compress.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3a_compress.F	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/cv3a_compress.F	(revision 1669)
@@ -116,16 +116,16 @@
  110  continue
 
-      do 121 j=1,ntra
-ccccc      do 111 k=1,nl+1
-      do 111 k=1,nd
-       nn=0
-      do 101 i=1,len
-      if(iflag1(i).eq.0)then
-       nn=nn+1
-       tra(nn,k,j)=tra1(i,k,j)
-      endif
- 101  continue
- 111  continue
- 121  continue
+!AC!      do 121 j=1,ntra
+!AC!ccccc      do 111 k=1,nl+1
+!AC!      do 111 k=1,nd
+!AC!       nn=0
+!AC!      do 101 i=1,len
+!AC!      if(iflag1(i).eq.0)then
+!AC!       nn=nn+1
+!AC!       tra(nn,k,j)=tra1(i,k,j)
+!AC!      endif
+!AC! 101  continue
+!AC! 111  continue
+!AC! 121  continue
 
       if (nn.ne.ncum) then
Index: LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F	(revision 1669)
@@ -9,4 +9,7 @@
      :         ,Plim1,Plim2,asupmax,supmax0
      :         ,asupmaxmin
+!AC!
+     :         ,da,phi
+!AC!
      o         ,iflag1,kbas1,ktop1
      :         ,precip1,cbmf1,plcl1,plfc1,wbeff1,sig1,w01,ptop21
@@ -17,5 +20,8 @@
      :         ,ftd1,fqd1
      :         ,Plim11,Plim21,asupmax1,supmax01
-     :         ,asupmaxmin1     )
+     :         ,asupmaxmin1     
+!AC!
+     :         ,da1,phi1  )
+!AC!
 ***************************************************************
 *                                                             *
@@ -50,5 +56,7 @@
       real asupmax(nloc,nd),supmax0(nloc)
       real asupmaxmin(nloc)
-
+!AC!
+      real da(nloc,nd),phi(nloc,nd,nd)
+!AC!
 c outputs:
       integer iflag1(len),kbas1(len),ktop1(len)
@@ -68,4 +76,7 @@
       real asupmax1(len,nd),supmax01(len)
       real asupmaxmin1(len)
+!AC!
+      real da1(nloc,nd),phi1(nloc,nd,nd)
+!AC!
 c
 c local variables:
@@ -111,5 +122,8 @@
             fqd1(idcum(i),k)=fqd(i,k)
             asupmax1(idcum(i),k)=asupmax(i,k)
- 2010     continue
+!AC!
+            da1(idcum(i),k)=da(i,k)
+!AC!
+ 2010    continue
  2020   continue
 
@@ -119,12 +133,23 @@
 
 
-        do 2100 j=1,ntra
-c oct3         do 2110 k=1,nl
-         do 2110 k=1,nd ! oct3
-          do 2120 i=1,ncum
-            ftra1(idcum(i),k,j)=ftra(i,k,j)
- 2120     continue
- 2110    continue
- 2100   continue
+!AC!        do 2100 j=1,ntra
+!AC!c oct3         do 2110 k=1,nl
+!AC!         do 2110 k=1,nd ! oct3
+!AC!          do 2120 i=1,ncum
+!AC!            ftra1(idcum(i),k,j)=ftra(i,k,j)
+!AC! 2120     continue
+!AC! 2110    continue
+!AC! 2100   continue
+
+!AC!
+       do j=1,nd
+         do k=1,nd 
+          do i=1,ncum
+            phi1(idcum(i),k,j)=phi(i,k,j)
+          end do
+         end do
+        end do
+!AC!
+
 c
 c        do 2220 k2=1,nd
Index: LMDZ5/branches/testing/libf/phylmd/cv3p_mixing.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3p_mixing.F	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/cv3p_mixing.F	(revision 1669)
@@ -118,9 +118,14 @@
             elij(i,k,j)=0.0
             hent(i,k,j)=0.0
-            ment(i,k,j)=0.0
-            sij(i,k,j)=0.0
+!AC!            ment(i,k,j)=0.0
+!AC!            sij(i,k,j)=0.0
  385      continue
  390    continue
  400  continue
+
+!AC!
+      ment(1:ncum,1:nd,1:nd)=0.0
+      sij(1:ncum,1:nd,1:nd)=0.0
+!AC!
 
       do k=1,ntra
Index: LMDZ5/branches/testing/libf/phylmd/cva_driver.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cva_driver.F	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/cva_driver.F	(revision 1669)
@@ -20,5 +20,8 @@
      &                   ftd1,fqd1,
      &                   Plim11,Plim21,asupmax1,supmax01,asupmaxmin1
-     &                   ,lalim_conv)
+     &                   ,lalim_conv, 
+!AC!
+     &                   da1,phi1)
+!AC!
 ***************************************************************
 *                                                             *
@@ -171,4 +174,8 @@
       real tvp1(len,nd)
 c
+!AC!
+      real da1(len,nd),phi1(len,nd,nd)
+      real da(len,nd),phi(len,nd,nd)
+!AC!
       real ftd1(len,nd)
       real fqd1(len,nd)
@@ -912,4 +919,16 @@
       endif
 
+!AC!
+!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+! --- passive tracers
+!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+
+      if (iflag_con.eq.3) then
+       CALL cv3_tracer(nloc,len,ncum,nd,nd,
+     :                  ment,sij,da,phi)
+      endif
+
+!AC!
+
 !^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 ! --- UNCOMPRESS THE FIELDS
@@ -928,4 +947,7 @@
      :          ,Plim1,Plim2,asupmax,supmax0
      :          ,asupmaxmin
+!AC!
+     :          ,da,phi
+!AC!
      o          ,iflag1,kbas1,ktop1
      o          ,precip1,cbmf1,plcl1,plfc1,wbeff1,sig1,w01,ptop21
@@ -936,5 +958,8 @@
      o          ,ftd1,fqd1
      o          ,Plim11,Plim21,asupmax1,supmax01
-     o          ,asupmaxmin1)
+     o          ,asupmaxmin1
+!AC!
+     o          ,da1,phi1)
+!AC!
       endif
 
Index: LMDZ5/branches/testing/libf/phylmd/inistats.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/inistats.F	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/inistats.F	(revision 1669)
@@ -18,5 +18,4 @@
       real, dimension(istime) :: lt
       integer :: nvarid
-      real, dimension(llm) :: pseudoalt
 
       write (*,*) 
